package control;

import view.WorldView;
import model.Customers;
import model.DataReader;
import model.Solution;
import model.TabuSearch;
import model.fillingFunction.*;
import model.innerSolver.SolomonHeuristic;

public class BigBang
{

	/**
	 * Instantiate all the needed top level objects needed to run the simulation.
	 */
	public void run ()
	{
		DataReader dr = new DataReader("./src/data/rc108.txt");
		Customers customers = new Customers(dr);

		AbstractFillingFunction testFillingFunction = new InitialFillingFunction(customers, 1.0);
		SolomonHeuristic sh = new SolomonHeuristic(customers, dr.getCapacity(), testFillingFunction);
		Solution solution = sh.GetInitialSolution();

		TabuSearch ts = new TabuSearch(dr, solution,  sh, testFillingFunction, 7, 3, 2, 1, false);

		InteractiveController controller = new InteractiveController(ts, null);

		WorldView worldView = new WorldView(ts, controller);
		ts.addObserver(worldView);
		controller.addObserver(worldView);
	}

	/**
	 * @param args
	 * @throws NumberFormatException
	 */
	public static void main (String[] args)
	{
		BigBang main = new BigBang();

		// Needed to avoid ScannerErrors (InputMismatch) due to format of
		// doubles
		java.util.Locale.setDefault(java.util.Locale.ENGLISH);

		main.run();
	}

}
