package model.fillingFunction;

import java.util.List;

import model.Customers;

public class InitialFillingFunction extends AbstractFillingFunction
{
	private double alpha;

	/**
	 * 
	 * @param customers
	 */
	public InitialFillingFunction (Customers customers, double alpha)
	{
		super(customers);
		this.alpha = alpha;
	}

	@Override
	public double calculate (List<Integer> customersVisiting, int numbersOfCustomersVisiting,
			List<Double> arrivalTimes, int capacityUsed)
	{
		double a = alpha * capacityUsed / customers.getTotalDemand();
		// subtract 1 to adjust for depot.
		double c = numbersOfCustomersVisiting - 1;
		double d = customers.getNumberOfCustomers() - 1;
		double fillingFunction = a + c / d;

		return fillingFunction;
	}

	@Override
	public String toString ()
	{
		return "Initial filling function \t alpha=" + alpha;
	}
}
