package model.fillingFunction;

import java.util.List;

import model.Customers;

public class TestFillingFunction extends AbstractFillingFunction
{
	private double a1;
	private double a2;
	private double a3;
	private double a4;
	private double a5;
	private double a6;
	private double a7;
	private double a8;
	private double a9;

	/**
	 * 
	 * @param customers
	 */
	public TestFillingFunction (Customers customers, double a1, double a2, double a3, double a4, double a5, double a6, double a7, double a8, double a9)
	{
		super(customers);
		double numerator = a1 + a2 + a3 + a4 + a5 + a6 + a7 + a8 + a9;
		this.a1 = a1 / numerator;
		this.a2 = a2 / numerator;
		this.a3 = a3 / numerator;
		this.a4 = a4 / numerator;
		this.a5 = a5 / numerator;
		this.a6 = a6 / numerator;
		this.a7 = a7 / numerator;
		this.a8 = a8 / numerator;
		this.a9 = a9 / numerator;
	}

	@Override
	public double calculate (List<Integer> customersVisiting, int numbersOfCustomersVisiting, List<Double> arrivalTimes, int capacityUsed)
	{
		double a_1 = capacityUsed / customers.getTotalDemand();
		// subtract 1 to adjust for depot.
		double a_2 = numbersOfCustomersVisiting - 1;
		double a_3 = customers.getNumberOfCustomers() - 1;
		double fillingFunction = a_1 - a_2 / a_3;

		double arrivalTimeFactor = 1.0;
		double minArrivalTime = Double.MAX_VALUE;
		double avrArrivalTime = 0.0;
		double maxArrivalTime = 0.0;
		double t_1;
		double t_2;

		double costFactor = 1.0;
		double minDistance = Double.MAX_VALUE;
		double avrDistance = 0.0;
		double maxDistance = 0.0;
		double d;

		for (int i = 0; i < numbersOfCustomersVisiting - 1; i++)
		{
			t_1 = arrivalTimes.get(i);
			t_2 = arrivalTimes.get(i + 1);

			arrivalTimeFactor *= (t_2 - t_1);
			if (t_2 - t_1 < minArrivalTime)
				minArrivalTime = t_2 - t_1;

			if (t_2 - t_1 > maxArrivalTime)
				maxArrivalTime = t_2 - t_1;

			avrArrivalTime += t_1;

			d = customers.Distance(customersVisiting.get(i), customersVisiting.get(i + 1));
			costFactor *= d;

			if (d < minDistance)
				minDistance = d;

			if (d > maxDistance)
				maxDistance = d;

			avrDistance += d;
		}

		avrArrivalTime = (avrArrivalTime + arrivalTimes.get(numbersOfCustomersVisiting - 1)) / numbersOfCustomersVisiting;
		avrDistance /= numbersOfCustomersVisiting;

		return a1 * arrivalTimeFactor + a2 * costFactor + a3 * fillingFunction + a4 * minArrivalTime + a5 * avrArrivalTime + a6 * maxArrivalTime + a7
				* minDistance + a8 * avrDistance + a9 * maxDistance;
	}

	@Override
	public String toString ()
	{
		String separator = "\t&";
		return a1 + separator + a2 + separator + a3 + separator + a4 + separator + a5 + separator + a6 + separator + a7 + separator + a8 + separator + a9;
		// return "Test filling function \t ATFactor=" + a1 + "\t cFactor=" + a2 + "\t filling=" + a3 +
		// "\t minAT=" + a4 + "\t avrAT=" + a5 + "\t maxAT=" + a6 + "\t minC=" + a7
		// + "\t avrC=" + a8 + "\t maxC=" + a9;
	}
}
