package model.innerSolver;

import java.util.List;

import model.Customers;
import model.Solution;
import model.fillingFunction.AbstractFillingFunction;

public abstract class AbstractInnerSolver
{
	protected Customers customers;
	protected int capacity;
	protected AbstractFillingFunction fillingFunction;

	public AbstractInnerSolver (Customers customers, int capacity, AbstractFillingFunction fillingFunction)
	{
		this.customers = customers;
		this.capacity = capacity;
		this.fillingFunction = fillingFunction;
	}

	/**
	 * Returns an initial solution where all the customers are visited.
	 */
	public abstract Solution GetInitialSolution ();

	/**
	 * Returns a solution where the customers given as argument are visited. List can only contain
	 * depot at first position if at all.
	 */
	public abstract Solution GetSolution (List<Integer> customers);
}
