package test;

import junit.framework.Assert;

import model.DataReader;

import org.junit.Before;
import org.junit.Test;

public class DataReader_Test extends AbstractTestCase
{
	private int[][] data;

	@Before
	public void setUp () throws Exception
	{
		baseSetUp();
		data = drFull.getData();
	}

	@Test
	public void testCustomersR101 ()
	{
		// Depot
		Assert.assertEquals(300, data[0][0] + data[1][0] + data[2][0] + data[3][0] + data[4][0]
				+ data[5][0]);
		// Random customer data
		Assert.assertEquals(5, data[1][15]);
		Assert.assertEquals(10, data[5][100]);
		Assert.assertEquals(69, data[3][75]);
		Assert.assertEquals(18, data[0][100]);
		Assert.assertEquals(18, data[1][100]);
	}

	@Test
	public void testGettersR101 ()
	{
		Assert.assertEquals(101, drFull.getNumberOfCustomers());
		Assert.assertEquals(25, drFull.getNumberOfVehicles());
		Assert.assertEquals(200, drFull.getCapacity());
		Assert.assertEquals(true, drFull.isDidRead());
	}

	@Test
	public void testSmallData ()
	{
		DataReader dataReader = new DataReader("./src/unittest_data/small_data.txt");
		Assert.assertEquals(5, dataReader.getNumberOfCustomers());
		Assert.assertEquals(25, dataReader.getNumberOfVehicles());
		Assert.assertEquals(200, dataReader.getCapacity());
		Assert.assertEquals(true, dataReader.isDidRead());
	}

}
