package test;

import java.util.LinkedList;
import java.util.List;

import junit.framework.Assert;
import model.Solution;
import model.innerSolver.SolomonHeuristic;

import org.junit.Before;
import org.junit.Test;

public class SolomonHeuristic_Test extends AbstractTestCase
{
	private SolomonHeuristic solomonHeuristic;
	
	@Before
	public void setUp () throws Exception
	{
		baseSetUp();
		solomonHeuristic = new SolomonHeuristic(customersFull, 200, fillingFunction);
	}

	@Test
	public void test ()
	{
		Solution sol = solomonHeuristic.GetInitialSolution();
		Assert.assertEquals(100, sol.getCustomersVisited().size());
		Assert.assertEquals(100, sol.getCustomerRoutes().length);
	}

	@Test
	public void testGetSolution ()
	{
		List<Integer> list = new LinkedList<Integer>();
		list.add(65);
		list.add(1);
		list.add(2);
		list.add(3);
		list.add(4);
		Solution sol = solomonHeuristic.GetSolution(list);
		Assert.assertFalse(sol.isValid());
		Assert.assertEquals(2, sol.getVehicles().length);
	}
}
