package test;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

public class TabuList_Test extends AbstractTestCase
{

	@Before
	public void setUp () throws Exception
	{
		baseSetUp();
	}

	@Test
	public void testTabuList ()
	{
		Assert.assertFalse(tabuList.contains(1.0));
		tabuList.addMove(1.0);
		Assert.assertTrue(tabuList.contains(1.0));
		tabuList.reset();
		Assert.assertFalse(tabuList.contains(1.0));
	}

	@Test
	public void testContainsZero ()
	{
		Assert.assertTrue(tabuList.contains(0.0));
	}

	@Test(expected = IllegalArgumentException.class)
	public void testAddSameNumber ()
	{
		tabuList.addMove(3.14);
		Assert.assertTrue(tabuList.contains(3.14));
		tabuList.addMove(3.14);
		Assert.assertTrue(tabuList.contains(3.14));
	}

	@Test
	public void testFillUpTabuList ()
	{
		tabuList.addMove(3.14);
		tabuList.addMove(2.78);
		tabuList.addMove(1.4142);
		tabuList.addMove(0.142857);
		tabuList.addMove(0.1442);
		tabuList.addMove(0.14422);
		tabuList.addMove(0.1442232);
		Assert.assertFalse(tabuList.contains(3.14));
		Assert.assertFalse(tabuList.contains(2.78));
		Assert.assertFalse(tabuList.contains(1.4142));
		Assert.assertTrue(tabuList.contains(0.1442));
	}
}
