/**
 * 
 */
package view;

import java.util.Observable;

import javax.swing.JPanel;
import javax.swing.JTextArea;

import control.InteractiveController;

import model.*;

/**
 * @author jerome
 * 
 */
public class StatusPanel extends JPanel
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JTextArea textArea;
	private TabuSearch ts;
	private int counter = 0;

	public StatusPanel (TabuSearch ts)
	{
		textArea = new JTextArea(3, 50);
		textArea.setEditable(false);
		this.add(textArea);
		
		this.ts = ts;
		
		update(ts);
	}

	public void update (Observable observable)
	{
		counter++;
		Solution sol = null;
		
		if (observable instanceof TabuSearch)
			sol = ((TabuSearch) observable).getWorkingSolution();
		else if (observable.getClass() == InteractiveController.class)
			sol = ((InteractiveController) observable).getTs().getWorkingSolution();
		
		String string = "Number of vehicles: " + sol.numberOfVehiclesUsed() + "\nCost: " + sol.getCosts() + "\n" + counter + "\n";

		if (ts.isFinished())
			textArea.setText(string);
		else
			textArea.setText(string + "Calculating...");
	}
}
